%define anolis_release 2

%global MAKEARG PSM_HAVE_SCIF=0 MIC=0

Name:           infinipath-psm
Summary:        Intel Performance Scaled Messaging (PSM) Libraries
Version:        3.3
Release:        %{anolis_release}%{?dist}
License:        GPLv2 or BSD
ExclusiveArch:  x86_64
URL:            https://github.com/01org/psm

Source0:        https://github.com/intel/psm/archive/v%{version}/psm-%{version}.tar.gz
Source1:        ipath.rules

Patch1:         0001-fix-a-compilation-issue.patch
Patch2:         adjust-base-cflags.patch
Patch4:         0001-Include-sysmacros.h.patch
Patch5:         0001-Extend-buffer-for-uvalue-and-pvalue.patch
Patch6:         extend-fdesc-array.patch
Patch7:         psm-multiple-definition.patch
Patch8:         infinipath-psm-gcc11.patch

Patch1000:      1000-Use-uname-m-instead-of-p.patch
Patch1001:      1001-QL-Prevent-format-errors-when-compiling-with-Wformat.patch

Requires:       udev
BuildRequires:  gcc
BuildRequires:  libuuid-devel
BuildRequires:  systemd-rpm-macros
BuildRequires:  make
Obsoletes:      infinipath-libs <= %{version}-%{release}

%description
The PSM Messaging API, or PSM API, is Intel's low-level
user-level communications interface for the True Scale
family of products. PSM users are enabled with mechanisms
necessary to implement higher level communications
interfaces in parallel environments.

%package devel
Summary:        Development files for Intel PSM
Requires:       %{name} = %{version}-%{release}
Obsoletes:      infinipath-devel <= %{version}-%{release}

%description devel
Development files for the %{name} library.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q -n psm-%{version}
%autopatch -p1

%build
# LTO seems to trigger a post-build failure as some symbols with external scope
# are "leaking".
%define _lto_cflags %{nil}

%{set_build_flags}
%make_build PSM_USE_SYS_UUID=1 %{MAKEARG} CC=gcc

%install
%make_install %{MAKEARG}
install -d %{buildroot}%{_udevrulesdir}
install -m 0644 %{SOURCE1} %{buildroot}%{_udevrulesdir}/60-ipath.rules

%generate_compatibility_deps

%files
%{_udevrulesdir}/60-ipath.rules
%{_libdir}/libpsm_infinipath.so.*
%{_libdir}/libinfinipath.so.*
%license COPYING
%dir %{abidir}
%{abidir}/libinfinipath.dump
%{abidir}/libpsm_infinipath.dump

%files devel
%{_libdir}/libpsm_infinipath.so
%{_libdir}/libinfinipath.so
%{_includedir}/psm.h
%{_includedir}/psm_mq.h

%files doc
%doc README

%changelog
* Thu Dec 14 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.3-2
- rebuild

* Mon Mar 27 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 3.3-1
- Init from upstream
